## ros-melodic-libmavconn 1.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(libmavconn)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED)

## System dependencies are found with CMake's conventions
find_package(console_bridge REQUIRED)
find_package(Boost REQUIRED COMPONENTS system)

# add package modules path, not needed in dependend packages
list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
include(EnableCXX11)
include(MavrosMavlink)

# Fixed in mavlink 2016.7.7
#-> enum values out of int range
#list(APPEND IGNORE_DIALECTS "autoquad")

###################################
## catkin specific configuration ##
###################################
catkin_package(
  INCLUDE_DIRS include
  LIBRARIES mavconn
  DEPENDS Boost console_bridge mavlink
  CFG_EXTRAS libmavconn-extras.cmake
)

###########
## Build ##
###########

include_directories(
  include
  ${CMAKE_CURRENT_BINARY_DIR}/catkin_generated/include
  ${Boost_INCLUDE_DIRS}
  ${mavlink_INCLUDE_DIRS}
  ${console_bridge_INCLUDE_DIRS}
)

## Declare a cpp library
add_library(mavconn
  ${CMAKE_CURRENT_BINARY_DIR}/catkin_generated/src/mavlink_helpers.cpp
  src/interface.cpp
  src/serial.cpp
  src/tcp.cpp
  src/udp.cpp
)
target_link_libraries(mavconn
  ${Boost_LIBRARIES}
  ${console_bridge_LIBRARIES}
)

# Use catkin-supplied em_expand macros to generate source files
em_expand(${CMAKE_CURRENT_SOURCE_DIR}/mavlink.context.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/catkin_generated/mavlink.context.py
  ${CMAKE_CURRENT_SOURCE_DIR}/include/mavconn/mavlink_dialect.h.em
  ${CMAKE_CURRENT_BINARY_DIR}/catkin_generated/include/mavconn/mavlink_dialect.h)

em_expand(${CMAKE_CURRENT_SOURCE_DIR}/mavlink.context.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/catkin_generated/mavlink.context.py
  ${CMAKE_CURRENT_SOURCE_DIR}/src/mavlink_helpers.cpp.em
  ${CMAKE_CURRENT_BINARY_DIR}/catkin_generated/src/mavlink_helpers.cpp)

message(STATUS "Copy mavlink_dialect.h to source tree")
file(
  COPY ${CMAKE_CURRENT_BINARY_DIR}/catkin_generated/include/mavconn/mavlink_dialect.h
  DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/include/mavconn/
  )

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

## Mark executables and/or libraries for installation
install(TARGETS mavconn
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

## Mark cpp header files for installation
install(DIRECTORY include/mavconn/
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/mavconn
  FILES_MATCHING PATTERN "*.h"
)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/catkin_generated/include/mavconn/
  DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/mavconn
  FILES_MATCHING PATTERN "*.h"
)

## Install cmake files (thanks to cmake_modules package)
install(DIRECTORY cmake/Modules
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/cmake
)

#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(mavconn-test test/test_mavconn.cpp)
  target_link_libraries(mavconn-test mavconn pthread)
endif()

# vim: ts=2 sw=2 et:

=== debian/changelog ===
ros-melodic-libmavconn (1.5.0-1stretch) stretch; urgency=high

  * libmavconn: Fix build warnings
  * Contributors: Morten Fyhn Amundsen

 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 11 Nov 2020 00:00:00 -0000

ros-melodic-libmavconn (1.4.0-1stretch) stretch; urgency=high

  * Dispatch GCS IP address
  * Contributors: Morten Fyhn Amundsen

 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 11 Sep 2020 00:00:00 -0000

ros-melodic-libmavconn (1.3.0-1stretch) stretch; urgency=high

  * allow mavros to compile in CI environment
  * Contributors: Marcelino

 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 08 Aug 2020 00:00:00 -0000

ros-melodic-libmavconn (1.2.0-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 22 May 2020 00:00:00 -0000

ros-melodic-libmavconn (1.1.0-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 04 Apr 2020 00:00:00 -0000

ros-melodic-libmavconn (1.0.0-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 01 Jan 2020 00:00:00 -0000

ros-melodic-libmavconn (0.33.4-1stretch) stretch; urgency=high

  * add macro for get_io_service() to work with boost>1.70
  * Contributors: acxz

 -- Vladimir Ermakov <vooon341@gmail.com>  Thu, 12 Dec 2019 00:00:00 -0000

ros-melodic-libmavconn (0.33.3-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 13 Nov 2019 00:00:00 -0000

ros-melodic-libmavconn (0.33.2-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 13 Nov 2019 00:00:00 -0000

ros-melodic-libmavconn (0.33.1-1stretch) stretch; urgency=high

  * resolved merge conflict
  * Contributors: David Jablonski

 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 11 Nov 2019 00:00:00 -0000

ros-melodic-libmavconn (0.33.0-1stretch) stretch; urgency=high

  * libmavconn: simplify parse_buffer, and fix dropped_packets and parse_error counters
    Currently the dropped_packets & parse_error counters are always published as 0 in mavros_diag.cpp.
    This seems to be caused by using the wrong status struct.
    Seems like mavros was editing m_status after mavlink_frame_char_buffer. This struct
    seems to be the parsing state, and looks like it shouldn't be modified by the caller (for example
    status->parse_error is zeroed out in the end of mavlink_frame_char_buffer).
    Also, the crc & signature checks done in mavros seems redundant.
    r_mavlink_status seems to be the struct that holds the mavlink connection information, therefore I
    changed get_status to return it instead.
    This fixes #1285 <https://github.com/mavlink/mavros/issues/1285>.
  * Contributors: Koby Aizer

 -- Vladimir Ermakov <vooon341@gmail.com>  Thu, 10 Oct 2019 00:00:00 -0000

ros-melodic-libmavconn (0.32.2-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 09 Sep 2019 00:00:00 -0000

ros-melodic-libmavconn (0.32.1-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Thu, 08 Aug 2019 00:00:00 -0000

ros-melodic-libmavconn (0.32.0-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 06 Jul 2019 00:00:00 -0000

ros-melodic-libmavconn (0.31.0-1stretch) stretch; urgency=high

  * readme: fix udp-pb formatting
  * Contributors: Vladimir Ermakov

 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 07 Jun 2019 00:00:00 -0000

ros-melodic-libmavconn (0.30.0-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 20 May 2019 00:00:00 -0000

ros-melodic-libmavconn (0.29.2-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 06 Mar 2019 00:00:00 -0000

ros-melodic-libmavconn (0.29.1-1stretch) stretch; urgency=high

  * All: catkin lint files
  * Contributors: Pierre Kancir

 -- Vladimir Ermakov <vooon341@gmail.com>  Sun, 03 Mar 2019 00:00:00 -0000

ros-melodic-libmavconn (0.29.0-1stretch) stretch; urgency=high

  * Merge branch 'master' into param-timeout
  * libmavconn: Fix building without installation. Detect CI environment
  * ci:test: temporary disable failed udp bind test
  * mavconn:pkg: Move generated files to build tree
  * Contributors: Vladimir Ermakov

 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 02 Feb 2019 00:00:00 -0000

ros-melodic-libmavconn (0.28.0-1stretch) stretch; urgency=high

  * libmavconn: add the possibility to set the source component ID through the send_message method
  * Contributors: TSC21

 -- Vladimir Ermakov <vooon341@gmail.com>  Thu, 03 Jan 2019 00:00:00 -0000

ros-melodic-libmavconn (0.27.0-1stretch) stretch; urgency=high

  * bind should be called after reuse_address is set
  * Contributors: Shahar Kosti

 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 12 Nov 2018 00:00:00 -0000

ros-melodic-libmavconn (0.26.3-1stretch) stretch; urgency=high

  * Prevent MAVConnTCPClient::do_recv and MAVConnTCPServer::do_accept from running after destruction has begun
  * libmavconn/CMakeLists.txt: link mavconn-test against pthread
  * Contributors: mlvov

 -- Vladimir Ermakov <vooon341@gmail.com>  Tue, 21 Aug 2018 00:00:00 -0000

ros-melodic-libmavconn (0.26.2-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 08 Aug 2018 00:00:00 -0000

ros-melodic-libmavconn (0.26.1-1stretch) stretch; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Thu, 19 Jul 2018 00:00:00 -0000

ros-melodic-libmavconn (0.26.0-1stretch) stretch; urgency=high

  * libmavconn: add scheme for permanent UDP broadcasting
  * test python 3 f-string formatting
  * Contributors: Oleg Kalachev, Vladimir Ermakov

 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 06 Jun 2018 00:00:00 -0000

ros-melodic-libmavconn (0.25.1-1stretch) stretch; urgency=high

  * lib #1026 <https://github.com/mavlink/mavros/issues/1026>: fix logInform compat
  * lib #1026 <https://github.com/mavlink/mavros/issues/1026>: add compat header for older console-bridge
  * Contributors: Vladimir Ermakov



=== debian/control ===
Source: ros-melodic-libmavconn
Section: misc
Priority: optional
Maintainer: Vladimir Ermakov <vooon341@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libconsole-bridge-dev, libgtest-dev, ros-melodic-catkin, ros-melodic-mavlink, ros-melodic-rosunit
Homepage: http://wiki.ros.org/mavros
Standards-Version: 3.9.2

Package: ros-melodic-libmavconn
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libconsole-bridge-dev, ros-melodic-mavlink
Description: MAVLink communication library.
 This library provide unified connection handling classes and URL to connection object mapper. This library can be used in standalone programs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-libmavconn//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-libmavconn 1.16.0

=== debian/changelog ===
ros-melodic-libmavconn (1.16.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 05 May 2023 00:00:00 -0000

ros-melodic-libmavconn (1.15.0-1bionic) bionic; urgency=high

  * Merge pull request #1794 <https://github.com/mavlink/mavros/issues/1794> from rossizero/master
    libmavconn: fix MAVLink v1.0 output selection
  * libmavconn: fix MAVLink v1.0 output selection
    Fix #1787 <https://github.com/mavlink/mavros/issues/1787>
  * Contributors: Vladimir Ermakov, rosrunne

 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 30 Dec 2022 00:00:00 -0000

ros-melodic-libmavconn (1.14.0-1bionic) bionic; urgency=high

  * libmavconn: fix MAVLink v1.0 output selection
    Fix #1787 <https://github.com/mavlink/mavros/issues/1787>
  * Merge pull request #1775 <https://github.com/mavlink/mavros/issues/1775> from acxz/find-geographiclib
    use already installed FindGeographicLib.cmake
  * use already installed FindGeographicLib.cmake
  * Contributors: Vladimir Ermakov, acxz

 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 24 Sep 2022 00:00:00 -0000

ros-melodic-libmavconn (1.13.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Thu, 13 Jan 2022 00:00:00 -0000

ros-melodic-libmavconn (1.12.2-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Sun, 12 Dec 2021 00:00:00 -0000

ros-melodic-libmavconn (1.12.1-1bionic) bionic; urgency=high

  * mavconn: fix connection issue introduced by #1658 <https://github.com/mavlink/mavros/issues/1658>
  * Contributors: Vladimir Ermakov

 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 29 Nov 2021 00:00:00 -0000

ros-melodic-libmavconn (1.12.0-1bionic) bionic; urgency=high

  * Merge pull request #1658 <https://github.com/mavlink/mavros/issues/1658> from asherikov/as_bugfixes
    Fix multiple bugs
  * Fix multiple bugs
    - fix bad_weak_ptr on connect and disconnect
    - introduce new API to avoid thread race when assigning callbacks
    - fix uninitialized variable in TCP client constructor which would
    randomly block TCP server
    This is an API breaking change: if client code creates connections using
    make_shared<>() instead of open_url(), it is now necessary to call new
    connect() method explicitly.
  * Contributors: Alexander Sherikov, Vladimir Ermakov

 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 27 Nov 2021 00:00:00 -0000

ros-melodic-libmavconn (1.11.1-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 24 Nov 2021 00:00:00 -0000

ros-melodic-libmavconn (1.11.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 24 Nov 2021 00:00:00 -0000

ros-melodic-libmavconn (1.10.0-1bionic) bionic; urgency=high

  * Merge pull request #1626 <https://github.com/mavlink/mavros/issues/1626> from valbok/crash_on_shutdown
    Show ENOTCONN error instead of crash on socket's shutdown
  * Show ENOTCONN error instead of crash
    When a client suddenly drops the connection,
    socket.shutdown() will throw an exception:
    boost::exception_detail::clone_impl<boost::exception_detail::error_info_injector<boost::system::system_error> >
    what():  shutdown: Transport endpoint is not connected
    Showing an error in this common case looks more reasonable than crashing.
  * Contributors: Val Doroshchuk, Vladimir Ermakov

 -- Vladimir Ermakov <vooon341@gmail.com>  Thu, 04 Nov 2021 00:00:00 -0000

ros-melodic-libmavconn (1.9.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Thu, 09 Sep 2021 00:00:00 -0000

ros-melodic-libmavconn (1.8.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 05 May 2021 00:00:00 -0000

ros-melodic-libmavconn (1.7.1-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 05 Apr 2021 00:00:00 -0000

ros-melodic-libmavconn (1.7.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 05 Apr 2021 00:00:00 -0000

ros-melodic-libmavconn (1.6.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 15 Feb 2021 00:00:00 -0000

ros-melodic-libmavconn (1.5.2-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Tue, 02 Feb 2021 00:00:00 -0000

ros-melodic-libmavconn (1.5.1-1bionic) bionic; urgency=high

  * Fix test for renaming of HEARTBEAT
  * Initialise message structures
    Uninitialised Mavlink 2 extension fields were sent if the fields were
    not later set. Initialising the fields to zero is the default value for
    extension fields and appears to the receiver as though sender is unaware
    of Mavlink 2.
    Instances were found with regex below, more may exist:
    mavlink::[^:]+::msg::[^:={]+ ?[^:={]*;
  * Contributors: Rob Clarke

 -- Vladimir Ermakov <vooon341@gmail.com>  Mon, 04 Jan 2021 00:00:00 -0000

ros-melodic-libmavconn (1.5.0-1bionic) bionic; urgency=high

  * libmavconn: Fix build warnings
  * Contributors: Morten Fyhn Amundsen

 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 11 Nov 2020 00:00:00 -0000

ros-melodic-libmavconn (1.4.0-1bionic) bionic; urgency=high

  * Dispatch GCS IP address
  * Contributors: Morten Fyhn Amundsen

 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 11 Sep 2020 00:00:00 -0000

ros-melodic-libmavconn (1.3.0-1bionic) bionic; urgency=high

  * allow mavros to compile in CI environment
  * Contributors: Marcelino

 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 08 Aug 2020 00:00:00 -0000

ros-melodic-libmavconn (1.2.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Fri, 22 May 2020 00:00:00 -0000

ros-melodic-libmavconn (1.1.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Sat, 04 Apr 2020 00:00:00 -0000

ros-melodic-libmavconn (1.0.0-1bionic) bionic; urgency=high



 -- Vladimir Ermakov <vooon341@gmail.com>  Wed, 01 Jan 2020 00:00:00 -0000

ros-melodic-libmavconn (0.33.4-1bionic) bionic; urgency=high



=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Vladimir Ermakov <vooon341@gmail.com>
-Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libconsole-bridge-dev, libgtest-dev, ros-melodic-catkin, ros-melodic-mavlink, ros-melodic-rosunit
+Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libconsole-bridge-dev, libgtest-dev <!nocheck>, ros-melodic-catkin, ros-melodic-mavlink, ros-melodic-rosunit <!nocheck>
 Homepage: http://wiki.ros.org/mavros
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
